-- ====================================================================
-- Sistema    : Catering
-- Programador: Leonardo Monteiro
-- Data       : 29/02/2000
-- Descrio  : Importa e exporta apresentao.
-- ====================================================================
-- @H:\SISTEMAS\DBA\SQL\ORACLE\1910_COCSTP_IMPEXP_APRESENT
-- ====================================================================
create or replace PROCEDURE IMPEXP_APRESENT(
P_IDIMPEXP   IN CHAR, /* I: Importar    - E: Exportar */
P_IDTIPOPER  IN CHAR, /* 0: Acrescentar - 1: Sobrepor */
P_CDCIA      IN COMPANHIA.CDCIA%TYPE,
P_CDMANCIA   IN MANUALCIA.CDMANCIA%TYPE,
P_CDSERVICO  IN SERVMANUAL.CDSERVICO%TYPE, 
P_CDSERVICO  IN SERVMANUAL.CDSERVICO%TYPE, 
P_CDSUBGRU   IN VARCHAR,
P_CDMANAP    IN MANUALCIAAP.CDMANAP%TYPE,
P_CDFILIAL   IN FILIAL.CDFILIAL%TYPE,
P_CDCLASSE   IN SUBGRUSEMA.CDCLASSE%TYPE,
P_CDCICLO    IN SUBGRUSEMA.CDCICLO%TYPE,
P_DTAPRESUMA IN SUBGRUSEMA.DTAPRESUMA%TYPE
)
AS
V_DTINIVGMA DATE;
V_DTFIMVGMA DATE;

BEGIN
	IF P_IDIMPEXP = 'E' THEN
		IF P_IDTIPOPER = '1' THEN
      	/*DELETE FROM PRODSUBSEMA
         WHERE (CDFILIAL   = P_CDFILIAL ) AND
               (CDCIA      = P_CDCIA    ) AND
               (CDMANCIA   = P_CDMANCIA ) AND
               (CDSERVICO  = P_CDSERVICO);
      	DELETE FROM RECSUBSEMA
         WHERE (CDFILIAL   = P_CDFILIAL ) AND
               (CDCIA      = P_CDCIA    ) AND
               (CDMANCIA   = P_CDMANCIA ) AND
               (CDSERVICO  = P_CDSERVICO);
      	DELETE FROM SUBGRUSEMA
         WHERE (CDFILIAL   = P_CDFILIAL ) AND
               (CDCIA      = P_CDCIA    ) AND
               (CDMANCIA   = P_CDMANCIA ) AND
               (CDSERVICO  = P_CDSERVICO);*/
         /* Produtos e receitas do manual */
         DELETE FROM COMPPROD CP
         WHERE (EXISTS(SELECT CDPRODUTO
                       FROM (SELECT CDSUBGRU,CDESPEPROD,CDTIPOCOMP,CDPRODUTO
                             FROM PRODSUBSEMA
                             WHERE (CDFILIAL  = P_CDFILIAL ) AND
                                   (CDCIA     = P_CDCIA    ) AND
                                   (CDMANCIA  = P_CDMANCIA ) AND
                                   (CDSERVICO = P_CDSERVICO)
                            UNION
                             SELECT CDSUBGRU,CDESPEPROD,CDTIPOCOMP,CDRECEITA
                             FROM RECSUBSEMA
                             WHERE (CDFILIAL  = P_CDFILIAL ) AND
                                   (CDCIA     = P_CDCIA    ) AND
                                   (CDMANCIA  = P_CDMANCIA ) AND
                                   (CDSERVICO = P_CDSERVICO))
                       WHERE (CP.CDPRODUTO    = CDSUBGRU  ) AND
                             (CP.CDESPEPROD   = CDESPEPROD) AND
                             (CP.CDTIPOCOMP   = CDTIPOCOMP) AND
                             (CP.CDPRODINSUMO = CDPRODUTO ));
         /* Sub-grupos do manual */
         DELETE FROM ESPEPROD EP
         WHERE (EXISTS(SELECT CDSUBGRU
                       FROM SUBGRUSEMA
                       WHERE (CDFILIAL      = P_CDFILIAL ) AND
                             (CDCIA         = P_CDCIA    ) AND
                             (CDMANCIA      = P_CDMANCIA ) AND
                             (CDSERVICO     = P_CDSERVICO) AND
                             (EP.CDPRODUTO  = CDSUBGRU   ) AND
                             (EP.CDESPEPROD = CDESPEPROD ));

         DELETE FROM COMPPROD CP
         WHERE (EXISTS(SELECT CDSUBGRU
                       FROM SUBGRUSEMA
                       WHERE (CDFILIAL        = P_CDFILIAL ) AND
                             (CDCIA           = P_CDCIA    ) AND
                             (CDMANCIA        = P_CDMANCIA ) AND
                             (CDSERVICO       = P_CDSERVICO) AND
                             (CP.CDPRODUTO    = CDSUBGRU   ) AND
                             (CP.CDESPEPROD   = CDESPEPROD ) AND
                             (CP.CDTIPOCOMP   = CDTIPOCOMP ) AND
                             (CP.CDPRODINSUMO = CDPRODUTO  ));
      END IF;

      SELECT DTINIVGMA,DTFIMVGMA
      INTO V_DTINIVGMA,V_DTFIMVGMA
      FROM MANUALCIA
      WHERE (CDFILIAL = P_CDFILIAL) AND
            (CDCIA    = P_CDCIA   ) AND
            (CDMANCIA = P_CDMANCIA);
      /* SUBGRUSEAP -> SUBGRUSEMA */
      INSERT INTO SUBGRUSEMA
      (CDFILIAL,CDCIA,CDMANCIA,CDSERVICO,CDSUBGRU,/*IDSITSUMA,DTINIVGSUMA,
       DTFIMVGSUMA,IDPROTSUMA,*/VRPELOADSUMA,CDCLASSE,CDCICLO,DTAPRESUMA)
      (SELECT P_CDFILIAL,P_CDCIA,P_CDMANCIA,P_CDSERVICO,CDSUBGRU,/*'1',V_DTINIVGMA,
              V_DTFIMVGMA,'1',*/100,P_CDCLASSE,P_CDCICLO,P_DTAPRESUMA
       FROM SUBGRUSEAP
       WHERE (CDFILIAL = P_CDFILIAL) AND
             (CDCIA    = P_CDCIA   ) AND
             (CDMANAP  = P_CDMANAP ) AND
             ((P_CDSUBGRU = 'T') OR
              (INSTR(P_CDSUBGRU,'_'||CDSUBGRU||'_')>0)) AND
             (CDSUBGRU NOT IN (SELECT CDSUBGRU
                               FROM SUBGRUSEMA
                               WHERE (CDFILIAL  = P_CDFILIAL ) AND
                                     (CDCIA     = P_CDCIA    ) AND
                                     (CDMANCIA  = P_CDMANCIA ) AND
                                     (CDSERVICO = P_CDSERVICO))));
      /* RECSUBSEAP -> RECSUBSEMA */
      INSERT INTO RECSUBSEMA
      (CDFILIAL,CDCIA,CDMANCIA,CDSERVICO,CDSUBGRU,CDRECEITA,
       QTRECSUMA,SGUNIDADE,VRLOADRSUMA,/*IDSITRSUMA,DTINIVGRSUMA,DTFIMVGRSUMA,IDPROTRSUMA,*/
       CDCLASSE,CDCICLO/*,CDFILIREC*/)
      (SELECT P_CDFILIAL,P_CDCIA,P_CDMANCIA,P_CDSERVICO,RA.CDSUBGRU,RA.CDRECEITA,
              RA.QTRECSUAP,PO.SGUNIDADE,100,/*'1',V_DTINIVGMA,V_DTFIMVGMA,'1',*/
              P_CDCLASSE,P_CDCICLO/*,RA.CDFILIREC*/
       FROM RECSUBSEAP RA, RECEITA RE, PRODUTO PO
       WHERE (RE.CDRECEITA = PO.CDPRODUTO) AND
             (RA.CDFILIAL  = P_CDFILIAL  ) AND
             (RA.CDCIA     = P_CDCIA     ) AND
             (RA.CDMANAP   = P_CDMANAP   ) AND
             ((P_CDSUBGRU  = 'T') OR
              (INSTR(P_CDSUBGRU,'_'||RA.CDSUBGRU||'_')>0)) AND
             (RE.CDRECEITA = RA.CDRECEITA) AND
             /*(RE.CDFILIREC = RA.CDFILIREC) AND*/
             (RA.CDSUBGRU||'_'||RA.CDRECEITA NOT IN
              (SELECT CDSUBGRU||'_'||CDRECEITA
               FROM RECSUBSEMA
               WHERE (CDFILIAL    = P_CDFILIAL ) AND
                     (CDCIA       = P_CDCIA    ) AND
                     (CDMANCIA    = P_CDMANCIA ) AND
                     (CDCLASSE    = P_CDCLASSE ) AND
                     (CDCICLO     = P_CDCICLO  ) AND
                     (CDSERVICO   = P_CDSERVICO))));
      /* PRODSUBSEAP -> PRODSUBSEMA */
      INSERT INTO PRODSUBSEMA
      (CDFILIAL,CDCIA,CDMANCIA,CDSERVICO,CDSUBGRU,CDPRODUTO,
       QTPRODSUMA,SGUNIDADE,VRLOADPSUMA,/*IDSITPSUMA,DTINIVGPSUMA,
       DTFIMVGPSUMA,IDPROTPSUMA,*/CDCLASSE,CDCICLO)
      (SELECT P_CDFILIAL,P_CDCIA,P_CDMANCIA,P_CDSERVICO,PA.CDSUBGRU,PA.CDPRODUTO,
              PA.QTPRODSUAP,PR.SGUNIDADE,100,/*'1',V_DTINIVGMA,
              V_DTFIMVGMA,'1',*/P_CDCLASSE,P_CDCICLO
       FROM PRODSUBSEAP PA, PRODUTO PR
       WHERE (PA.CDFILIAL = P_CDFILIAL) AND
             (PA.CDCIA    = P_CDCIA   ) AND
             (PA.CDMANAP  = P_CDMANAP ) AND
             ((P_CDSUBGRU = 'T') OR
              (INSTR(P_CDSUBGRU,'_'||PA.CDSUBGRU||'_')>0)) AND
             (PR.CDPRODUTO = PA.CDPRODUTO) AND
             (PA.CDSUBGRU||'_'||PA.CDPRODUTO NOT IN
              (SELECT CDSUBGRU||'_'||CDPRODUTO
               FROM PRODSUBSEMA
               WHERE (CDFILIAL  = P_CDFILIAL ) AND
                     (CDCIA     = P_CDCIA    ) AND
                     (CDMANCIA  = P_CDMANCIA ) AND
                     (CDCLASSE  = P_CDCLASSE ) AND
                     (CDCICLO   = P_CDCICLO  ) AND 
                     (CDSERVICO = P_CDSERVICO))));

   ELSIF P_IDIMPEXP = 'I' THEN

		IF P_IDTIPOPER = '1' THEN
         DELETE FROM PRODSUBSEAP
         WHERE (CDFILIAL = P_CDFILIAL) AND
               (CDCIA    = P_CDCIA   ) AND
               (CDMANAP  = P_CDMANAP );
         DELETE FROM RECSUBSEAP
         WHERE (CDFILIAL = P_CDFILIAL) AND
               (CDCIA    = P_CDCIA   ) AND
               (CDMANAP  = P_CDMANAP );
         DELETE FROM SUBGRUSEAP
         WHERE (CDFILIAL = P_CDFILIAL) AND
               (CDCIA    = P_CDCIA  ) AND
               (CDMANAP  = P_CDMANAP);
		END IF;
      /* SUBGRUSEMA -> SUBGRUSEAP */
      INSERT INTO SUBGRUSEAP
      (CDFILIAL,CDCIA,CDMANAP,CDSUBGRU)
      (SELECT P_CDFILIAL,P_CDCIA,P_CDMANAP,CDSUBGRU
       FROM SUBGRUSEMA
       WHERE (CDFILIAL  = P_CDFILIAL ) AND
             (CDCIA     = P_CDCIA    ) AND
             (CDMANCIA  = P_CDMANCIA ) AND
             (CDSERVICO = P_CDSERVICO) AND
             ((P_CDSUBGRU = 'T') OR
              (INSTR(P_CDSUBGRU,'_'||CDSUBGRU||'_')>0)) AND
             (CDSUBGRU NOT IN (SELECT CDSUBGRU
                               FROM SUBGRUSEAP
                               WHERE (CDFILIAL = P_CDFILIAL) AND
                                     (CDCIA    = P_CDCIA   ) AND
                                     (CDMANAP  = P_CDMANAP ))));
      /* RECSUBSEMA -> RECSUBSEAP */
      INSERT INTO RECSUBSEAP
      (CDFILIAL,CDCIA,CDMANAP,CDSUBGRU,CDRECEITA,QTRECSUAP)
      (SELECT P_CDFILIAL,P_CDCIA,P_CDMANAP,CDSUBGRU,CDRECEITA,QTRECSUMA
       FROM RECSUBSEMA
       WHERE (CDFILIAL  = P_CDFILIAL ) AND
             (CDCIA     = P_CDCIA    ) AND
             (CDMANCIA  = P_CDMANCIA ) AND
             (CDSERVICO = P_CDSERVICO) AND
             (CDCLASSE  = P_CDCLASSE ) AND
             (CDCICLO   = P_CDCICLO  ) AND
             ((P_CDSUBGRU = 'T') OR
              (INSTR(P_CDSUBGRU,'_'||CDSUBGRU||'_')>0)) AND
             (CDSUBGRU||'_'||CDRECEITA NOT IN
              (SELECT CDSUBGRU||'_'||CDRECEITA
               FROM RECSUBSEAP
               WHERE (CDFILIAL = P_CDFILIAL) AND
                     (CDCIA    = P_CDCIA   ) AND
                     (CDMANAP  = P_CDMANAP ))));
      /* PRODSUBSEMA -> PRODSUBSEAP */
      INSERT INTO PRODSUBSEAP
      (CDFILIAL,CDCIA,CDMANAP,CDSUBGRU,CDPRODUTO,QTPRODSUAP)
      (SELECT P_CDFILIAL,P_CDCIA,P_CDMANAP,CDSUBGRU,CDPRODUTO,QTPRODSUMA
       FROM PRODSUBSEMA
       WHERE (CDFILIAL  = P_CDFILIAL ) AND
             (CDCIA     = P_CDCIA    ) AND
             (CDMANCIA  = P_CDMANCIA ) AND
             (CDSERVICO = P_CDSERVICO) AND
             (CDCLASSE  = P_CDCLASSE ) AND
             (CDCICLO   = P_CDCICLO  ) AND
             ((P_CDSUBGRU = 'T') OR
              (INSTR(P_CDSUBGRU,'_'||CDSUBGRU||'_')>0)) AND
             (CDSUBGRU||'_'||CDPRODUTO NOT IN
              (SELECT CDSUBGRU||'_'||CDPRODUTO
               FROM PRODSUBSEAP
               WHERE (CDFILIAL = P_CDFILIAL) AND
                     (CDCIA    = P_CDCIA   ) AND
                     (CDMANAP  = P_CDMANAP ))));

   END IF;
END;
/
