CREATE OR REPLACE PROCEDURE FCT_REGERAR_RATEIO_CENT_CUST (
	P_NRSEQCONTRATO  IN VARCHAR2,
	P_NRFATURACONT   IN VARCHAR2,
	P_CDOPERADOR     IN VARCHAR2
)
AS
 V_NRRATEIOITEMFAT   FCT_RATEIOITFATURACONT.NRRATEIOITEMFAT%TYPE;
 V_IDGERARATEIOCT    NUMBER;
 
 V_VRPARCELAFINAL NUMBER;
 V_SUMVRRATEADO   NUMBER;
 V_DIFERENCARAT   NUMBER;
 V_SUMPERCRATEADO NUMBER;
 V_DIFERENCAPERCRAT NUMBER;
 
BEGIN
	FOR C_PARCELA IN (SELECT FAT.NRFATURACONT, CONT.NRSEQCONTRATO, FAT.DTINICOMPET, FAT.DTFINCOMPET, CONT.NRORG
	                    FROM FCT_FATURACONT FAT
						JOIN FCT_RELACAGRUPCONTFAT RELAC
						  ON RELAC.NRFATURACONT = FAT.NRFATURACONT
						JOIN FCT_CONTRATO CONT
						  ON CONT.NRSEQCONTRATO = RELAC.NRSEQCONTRATO
					   WHERE ((FAT.NRFATURACONT = P_NRFATURACONT) OR (P_NRFATURACONT IS NULL))
					     AND ((CONT.NRSEQCONTRATO = P_NRSEQCONTRATO) OR (P_NRSEQCONTRATO IS NULL))) LOOP
						 
		DELETE FROM FCT_RATEIOITFATURACONT
		 WHERE NRFATURACONT = C_PARCELA.NRFATURACONT;
	     
		FOR C_ITENS IN (
			SELECT ITFAT.NRITFATURACONT,
				   ITFAT.VRVENCIMENTO,
				   ITFAT.VRNEGCONTR,
				   ITFAT.VRFALTAFATURAR,
				   ITFAT.VRFATURADO,
				   ITFAT.NRITEMOCONTRATO,
				   ITCONT.CDSERVORCA,
				   ITCONT.NRSEQCONTRATO
			  FROM FCT_ITFATURACONT ITFAT
			  JOIN FCT_ITEMCONTRATO ITCONT
				ON ITCONT.NRITEMOCONTRATO = ITFAT.NRITEMOCONTRATO
			 WHERE ITFAT.NRFATURACONT = C_PARCELA.NRFATURACONT
		) LOOP
		
			BEGIN
				SELECT COUNT(*)
				  INTO V_IDGERARATEIOCT
				  FROM FCT_RELACCONTRCENTCUST
				 WHERE NRSEQCONTRATO = C_ITENS.NRSEQCONTRATO;
			EXCEPTION WHEN NO_DATA_FOUND THEN
				V_IDGERARATEIOCT := 0;
			END;
			
			IF (V_IDGERARATEIOCT > 0) THEN

				  FOR C_ITENSRATEIO IN (
					  SELECT NRRELCONTRCENTCUST, NRSEQCONTRATO, CDCENTCUST, VRPERCENTUALCONTCCUST
						FROM FCT_RELACCONTRCENTCUST
					   WHERE NRSEQCONTRATO = C_ITENS.NRSEQCONTRATO
				  ) LOOP
						
					  BEGIN
						SELECT NRRATEIOITEMFAT
						  INTO V_NRRATEIOITEMFAT									
						  FROM FCT_RATEIOITFATURACONT
						 WHERE NRFATURACONT = C_PARCELA.NRFATURACONT
						   AND CDCENTCUST = C_ITENSRATEIO.CDCENTCUST
						   AND CDSERVORCA = C_ITENS.CDSERVORCA;
					  EXCEPTION 
						WHEN NO_DATA_FOUND THEN
							V_NRRATEIOITEMFAT := NULL;
						
					  END;
						
					  IF V_NRRATEIOITEMFAT IS NULL THEN
								  
						  NOVO_CODIGO_NT('FCT_RATEIOITFATURACONT', V_NRRATEIOITEMFAT, 1);
						  
						  INSERT INTO FCT_RATEIOITFATURACONT (
							  NRRATEIOITEMFAT, NRITFATURACONT,  NRFATURACONT,
							  NRSEQCONTRATO,   NRITEMOCONTRATO, NRESTRUTURAM,
							  CDCENTCUST,      VRPERCENTRATEIO, VRRATEADO,
							  NRORG,           IDATIVO,         DTINCLUSAO,
							  DTULTATU,        NRORGINCLUSAO,   CDOPERINCLUSAO,
							  NRORGULTATU,     CDOPERULTATU,    IDSITUVENCRATEIO,
							  NRAPURACAO,      CDSERVORCA
						  )
						  VALUES (
						  
							  V_NRRATEIOITEMFAT,          NULL,        C_PARCELA.NRFATURACONT,
							  NULL,                       NULL,        NULL,
							  C_ITENSRATEIO.CDCENTCUST,   ROUND(C_ITENSRATEIO.VRPERCENTUALCONTCCUST, 2), ROUND(NVL(C_ITENS.VRNEGCONTR, C_ITENS.VRVENCIMENTO) * (C_ITENSRATEIO.VRPERCENTUALCONTCCUST/100), 2),
							  C_PARCELA.NRORG,            'S',                                  SYSDATE,
							  NULL,                       C_PARCELA.NRORG,                      P_CDOPERADOR,
							  NULL,                       NULL,                                 '1',
							  NULL,                       C_ITENS.CDSERVORCA
						  );
					  ELSE
									 
						 UPDATE FCT_RATEIOITFATURACONT
							SET VRRATEADO = VRRATEADO + ROUND(NVL( C_ITENS.VRNEGCONTR, C_ITENS.VRVENCIMENTO) * (C_ITENSRATEIO.VRPERCENTUALCONTCCUST/100), 2)
						  WHERE NRRATEIOITEMFAT = V_NRRATEIOITEMFAT;
						
					  END IF;
					  
					  FOR C_PERC IN (SELECT NRRATEIOITEMFAT, NRSEQCONTRATO, NRITEMOCONTRATO, CDCENTCUST, VRPERCENTRATEIO, VRRATEADO, 
										   (SELECT DECODE(SUM(VRRATEADO),0, 1, SUM(VRRATEADO))
											  FROM FCT_RATEIOITFATURACONT 
											  WHERE NRFATURACONT = C_PARCELA.NRFATURACONT) AS SOMA
									   FROM FCT_RATEIOITFATURACONT 
									  WHERE NRFATURACONT = C_PARCELA.NRFATURACONT) LOOP
										
						UPDATE FCT_RATEIOITFATURACONT
						   SET VRPERCENTRATEIO = ((C_PERC.VRRATEADO*100)/ C_PERC.SOMA)
						 WHERE NRRATEIOITEMFAT = C_PERC.NRRATEIOITEMFAT;				

					  END LOOP;
						  
				  END LOOP; --C_ITENSRATEIO
				
			END IF;
			
		END LOOP;
		
		FOR C_NEGAPUR IN (SELECT NEG.NRSEQCONTRATO, PARCAPUR.NRFATURACONT, VRNEGCONTR
					 	    FROM FCT_NEGCONTRATO NEG
						    JOIN FCT_PARCELASAPURNEGCONTRATO PARCAPUR
							  ON PARCAPUR.NRNEGCONTRATO = NEG.NRNEGCONTRATO
							JOIN FCT_FATURACONT FAT
							  ON FAT.NRFATURACONT = PARCAPUR.NRFATURACONT
						   WHERE NEG.IDREALIZARNEGOCIACAO = 'A' 
						     AND NEG.NRSEQCONTRATO = C_PARCELA.NRSEQCONTRATO 
						     AND PARCAPUR.NRFATURACONT = C_PARCELA.NRFATURACONT
							 ) LOOP
							 
			 
			FOR C_ITENSRATEIO IN (
				SELECT NRRELCONTRCENTCUST, NRSEQCONTRATO, CDCENTCUST, VRPERCENTUALCONTCCUST
				  FROM FCT_RELACCONTRCENTCUST
				 WHERE NRSEQCONTRATO = C_NEGAPUR.NRSEQCONTRATO
			) LOOP
			
				BEGIN
					SELECT NRRATEIOITEMFAT
					  INTO V_NRRATEIOITEMFAT									
					  FROM FCT_RATEIOITFATURACONT
					 WHERE NRFATURACONT = C_NEGAPUR.NRFATURACONT
					   AND CDCENTCUST = C_ITENSRATEIO.CDCENTCUST;
				  EXCEPTION 
					WHEN NO_DATA_FOUND THEN
						V_NRRATEIOITEMFAT := NULL;
					
				END;
				
				IF V_NRRATEIOITEMFAT IS NOT NULL THEN
				
					UPDATE FCT_RATEIOITFATURACONT
							SET VRRATEADO = ROUND(C_NEGAPUR.VRNEGCONTR * (C_ITENSRATEIO.VRPERCENTUALCONTCCUST/100), 2)
						  WHERE NRRATEIOITEMFAT = V_NRRATEIOITEMFAT;
					
				END IF;
				
				FOR C_PERC IN (SELECT NRRATEIOITEMFAT, NRSEQCONTRATO, NRITEMOCONTRATO, CDCENTCUST, VRPERCENTRATEIO, VRRATEADO, 
								   (SELECT DECODE(SUM(VRRATEADO),0, 1, SUM(VRRATEADO))
									  FROM FCT_RATEIOITFATURACONT 
									  WHERE NRFATURACONT = C_NEGAPUR.NRFATURACONT) AS SOMA
							   FROM FCT_RATEIOITFATURACONT 
							  WHERE NRFATURACONT = C_NEGAPUR.NRFATURACONT) LOOP
										
						UPDATE FCT_RATEIOITFATURACONT
						   SET VRPERCENTRATEIO = ((C_PERC.VRRATEADO*100)/ C_PERC.SOMA)
						 WHERE NRRATEIOITEMFAT = C_PERC.NRRATEIOITEMFAT;
			
				END LOOP;

			END LOOP;
			
	    END LOOP;
		
		-- Garante que o valor esteja igual (Corrige diferena at 2 centavos, diferenas maiores no sero consideradas)
		
		BEGIN
			SELECT SUM(VRRATEADO)
			  INTO V_SUMVRRATEADO
			  FROM FCT_RATEIOITFATURACONT
			 WHERE NRFATURACONT = C_PARCELA.NRFATURACONT;
		EXCEPTION
			WHEN NO_DATA_FOUND THEN
				V_SUMVRRATEADO := 0;
		END;
		
		BEGIN
			SELECT NVL(VRNEGCONTR,VRVENCIMENTO)
			  INTO V_VRPARCELAFINAL
			  FROM FCT_FATURACONT
			 WHERE NRFATURACONT = C_PARCELA.NRFATURACONT;
		EXCEPTION
			WHEN NO_DATA_FOUND THEN
				V_VRPARCELAFINAL := 0;
		END;
		
		
		IF ((V_SUMVRRATEADO <> V_VRPARCELAFINAL) AND (ABS(V_SUMVRRATEADO - V_VRPARCELAFINAL) < 0.02)) THEN
			
			V_DIFERENCARAT := ABS(V_SUMVRRATEADO - V_VRPARCELAFINAL);
			
			IF (V_SUMVRRATEADO < V_VRPARCELAFINAL) THEN
			
				UPDATE FCT_RATEIOITFATURACONT
				   SET VRRATEADO = VRRATEADO + V_DIFERENCARAT
				 WHERE NRRATEIOITEMFAT = (SELECT MAX(NRRATEIOITEMFAT) FROM FCT_RATEIOITFATURACONT WHERE NRFATURACONT = C_PARCELA.NRFATURACONT);
				
			ELSE  
				
				UPDATE FCT_RATEIOITFATURACONT
				   SET VRRATEADO = VRRATEADO - V_DIFERENCARAT
				 WHERE NRRATEIOITEMFAT = (SELECT MAX(NRRATEIOITEMFAT) FROM FCT_RATEIOITFATURACONT WHERE NRFATURACONT = C_PARCELA.NRFATURACONT);
			
			END IF;
			
		END IF;
		
		-- regera os percentuais
		
		FOR C_PERC IN (SELECT NRRATEIOITEMFAT, NRSEQCONTRATO, NRITEMOCONTRATO, CDCENTCUST, VRPERCENTRATEIO, VRRATEADO, 
							   (SELECT DECODE(SUM(VRRATEADO),0, 1, SUM(VRRATEADO))
								  FROM FCT_RATEIOITFATURACONT 
								  WHERE NRFATURACONT = C_PARCELA.NRFATURACONT) AS SOMA
						   FROM FCT_RATEIOITFATURACONT 
						  WHERE NRFATURACONT = C_PARCELA.NRFATURACONT) LOOP
							
			UPDATE FCT_RATEIOITFATURACONT
			   SET VRPERCENTRATEIO = ROUND(((C_PERC.VRRATEADO*100)/ C_PERC.SOMA),2)
			 WHERE NRRATEIOITEMFAT = C_PERC.NRRATEIOITEMFAT;				

		 END LOOP;
		 
		 
		 -- Garante que o percentual seja 100%
		 
		 BEGIN 
			SELECT SUM(VRPERCENTRATEIO)
			  INTO V_SUMPERCRATEADO
			  FROM FCT_RATEIOITFATURACONT 
			 WHERE NRFATURACONT = C_PARCELA.NRFATURACONT;
		 EXCEPTION
			WHEN NO_DATA_FOUND THEN
			V_SUMPERCRATEADO := NULL;
		 END;
		 
		IF (V_SUMPERCRATEADO IS NOT NULL) THEN
		  
			IF ((V_SUMPERCRATEADO < 100) AND (V_SUMPERCRATEADO >= 98)) THEN
			
				V_DIFERENCAPERCRAT := 100- V_SUMPERCRATEADO;
				
				UPDATE FCT_RATEIOITFATURACONT
				   SET VRPERCENTRATEIO = VRPERCENTRATEIO + V_DIFERENCAPERCRAT
				 WHERE NRRATEIOITEMFAT = (SELECT MAX(NRRATEIOITEMFAT) FROM FCT_RATEIOITFATURACONT WHERE NRFATURACONT = C_PARCELA.NRFATURACONT);
			 
				
			ELSIF ((V_SUMPERCRATEADO > 100) AND (V_SUMPERCRATEADO  <= 102)) THEN
				
				V_DIFERENCAPERCRAT := V_SUMPERCRATEADO - 100;
				
				UPDATE FCT_RATEIOITFATURACONT
				   SET VRPERCENTRATEIO = VRPERCENTRATEIO - V_DIFERENCAPERCRAT
				 WHERE NRRATEIOITEMFAT = (SELECT MAX(NRRATEIOITEMFAT) FROM FCT_RATEIOITFATURACONT WHERE NRFATURACONT = C_PARCELA.NRFATURACONT);
				
			END IF;			
		END IF;				
	END LOOP;	
END;